(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

// @TODO LIVE
var def = require('./consts');

var RenderEngine420P = require('./webgl420'); // mem


var AU_FMT_READ = 10;
var MISSILE_PKT_GET_TYPE_AAC = 100;
var MISSILE_PKT_GET_TYPE_HAVE_VIDEO = 200;
var MISSILE_PKT_GET_TYPE_YUV = 300;
var MISSILE_PKT_GET_NOTHING = 404;
var MISSILE_PKT_GET_SPLIT_FINISHED = 405;
var READY_PUSH_COUNT_LIMIT = 0;

function getScriptPath(foo) {
  return window.URL.createObjectURL(new Blob([foo.toString().match(/^\s*function\s*\(\s*\)\s*\{(([\s\S](?!\}$))*[\s\S])/)[1]], {
    type: 'text/javascript'
  }));
}

var CHttpLiveCoreModule = /*#__PURE__*/function () {
  function CHttpLiveCoreModule(config) {
    (0, _classCallCheck2["default"])(this, CHttpLiveCoreModule);
    this.config = {
      width: config.width || def.DEFAULT_WIDTH,
      height: config.height || def.DEFAULT_HEIGHT,
      fps: config.fps || def.DEFAULT_FPS,
      sampleRate: config.sampleRate || def.DEFAULT_SAMPLERATE,
      playerId: config.playerId || def.DEFAILT_WEBGL_PLAY_ID,
      token: config.token || null,
      probeSize: config.probeSize || 4096
    }; // end this.config

    this.AVSniffPtr = null;
    this.AVGetInterval = null;
    this.AVDecodeInterval = null;
    this.ready_now = 0;
    this.cache_status = 1;
    this.download_length = 0;
    this.AVGLObj = null;
    this.CanvasObj = document.querySelector("#canvas");
    this.NaluBuf = [];
    this.YuvBuf = []; // fetch worker

    var _this = this; // console.warn("_this before AVSniffPtr:", _this);


    this.workerFetch = new Worker('./worker-fetch.js');

    this.workerFetch.onmessage = function (event) {
      _this._workerFetch_onmessage(event, _this);
    };

    this.totalLen = 0;
    this.pushPkg = 0;
  } // end func constructor


  (0, _createClass2["default"])(CHttpLiveCoreModule, [{
    key: "_workerFetch_onmessage",
    value: function _workerFetch_onmessage(event, _this) {
      // console.log("play -> workerFetch recv:", event, playerObj);
      var body = event.data;
      var cmd = null;

      if (body.cmd === undefined || body.cmd === null) {
        cmd = '';
      } else {
        cmd = body.cmd;
      } // console.log("play -> workerFetch recv cmd:", cmd);


      switch (cmd) {
        case 'fetch-chunk':
          //console.log("play -> workerFetch append chunk");
          var chunk = body.data;
          _this.download_length += chunk.length;
          var push_ret = 0;
          setTimeout(function () {
            var offset_video = Module._malloc(chunk.length);

            Module.HEAP8.set(chunk, offset_video); // console.warn("_this.AVSniffPtr:", _this);

            push_ret = Module.cwrap("pushSniffHttpFlvData", "number", ["number", "number", "number", "number"])(_this.AVSniffPtr, offset_video, chunk.length, 4096); // console.warn("pushRet:", push_ret);

            Module._free(offset_video);

            offset_video = null;
          }, 0); // end setTimeout

          _this.totalLen += chunk.length; //console.log("play -> workerFetch append chunk ret: ", push_ret, chunk.length, totalLen);

          _this.pushPkg++; // /*

          if (_this.AVGetInterval === undefined || _this.AVGetInterval === null) {
            _this.AVGetInterval = window.setInterval(function () {
              var bufLen = Module.cwrap("getBufferLengthApi", "number", ["number"])(_this.AVSniffPtr);
              console.log("play -> workerFetch last buf len: ", bufLen);

              if (bufLen > _this.config.probeSize) {
                // if (pushPkg > READY_PUSH_COUNT_LIMIT) {
                var get_ret = Module.cwrap("getSniffHttpFlvPkg", "number", ["number"])(_this.AVSniffPtr);
                console.log("play -> workerFetch get nalu ret: ", get_ret, _this.pushPkg);
                _this.pushPkg -= 1;
                _this.ready_now = 1; // }
              } // end if buf len check

            }, 5);
          } // end if AVGetInterval


          break;

        case 'fetch-fin':
          // fetchFinished = true;

          /*
          if (AVGetInterval !== undefined || AVGetInterval !== null) {
              console.log(" OVER========================>", AVGetInterval);
              window.clearInterval(AVGetInterval);
              AVGetInterval = null;
          }
          */
          break;

        default:
          break;
      } // end switch

    } // end function _workerFetch_onmessage
    // callback

  }, {
    key: "_callbackProbe",
    value: function _callbackProbe(duration, width, height, fps, audioIdx, sample_rate, channels, vcodec_name_id, sample_fmt) {
      var hex = Module.HEAPU8.subarray(sample_fmt, sample_fmt + AU_FMT_READ);
      var sample_fmt_str = "";

      for (var i = 0; i < hex.length; i++) {
        var _char = String.fromCharCode(hex[i]);

        sample_fmt_str += _char;
      }

      console.log("callbackProbe", duration, width, height, fps, audioIdx, sample_rate, channels, vcodec_name_id, sample_fmt_str);
    } // end func _callbackProbe

  }, {
    key: "_callbackYUV",
    value: function _callbackYUV(y, u, v, line_y, line_u, line_v, w, h, pts) {
      console.log("callbackYUV==============>", line_y, line_u, line_v, w, h, pts);
      var offsetY = Module.HEAPU8.subarray(y, y + line_y * h);
      var bufY = new Uint8Array(offsetY);
      var offsetU = Module.HEAPU8.subarray(u, u + line_u * h / 2);
      var bufU = new Uint8Array(offsetU);
      var offsetV = Module.HEAPU8.subarray(v, v + line_v * h / 2);
      var bufV = new Uint8Array(offsetV);
      var data = {
        //AVGLObj: AVGLObj,
        bufY: bufY,
        bufU: bufU,
        bufV: bufV,
        line_y: line_y,
        h: h,
        pts: pts
      };
      this.YuvBuf.push(data);

      if (this.cache_status > 0 && this.YuvBuf.length > 50) {
        console.log("YUV cache finished");
        this.cache_status = 0;
      } //renderFrame(AVGLObj, bufY, bufU, bufV, line_y, h);

      /*
      workerGL.postMessage({
          cmd: "start", 
          data: {
              AVGLObj: AVGLObj,
              bufY: bufY,
              bufU: bufU,
              bufV: bufV,
              line_y: line_y,
              h: h
          },
          msg: "start"
      });*/


      Module._free(offsetY);

      offsetY = null;

      Module._free(offsetU);

      offsetU = null;

      Module._free(offsetV);

      offsetV = null; //bufY = null;
      //bufU = null;
      //bufV = null;
    } // end func _callbackYUV

  }, {
    key: "_callbackNALU",
    value: function _callbackNALU(data, len, isKey, w, h, pts, dts) {
      //return;
      console.log("callbackNALU len", len);
      console.log("callbackNALU is key", isKey);
      console.log("callbackNALU w h", w, h);
      console.log("callbackNALU time HEVC dts", dts);
      var offsetFrame = Module.HEAPU8.subarray(data, data + len);
      var bufData = new Uint8Array(offsetFrame); //console.log("callbackNALU Data:", bufData);

      this.NaluBuf.push({
        bufData: bufData,
        len: len,
        isKey: isKey,
        w: w,
        h: h,
        pts: pts * 1000,
        dts: dts * 1000
      });
      /*
      let offset_video = Module._malloc(bufData.length);
      Module.HEAP8.set(bufData, offset_video);
       // decode start
      let decRet = Module.cwrap("decodeVideoFrame", "number", 
          ["number", "number", "number", "number", "number"])
          (AVSniffPtr, offset_video, bufData.length, pts, dts, 0);
      console.log("decodeVideoFrame ret:", decRet); 
      // decode end
       */
      //bufData = null;

      Module._free(offsetFrame);

      offsetFrame = null; //Module._free(offset_video);
      //offset_video = null;
    } // end func _callbackNALU

  }, {
    key: "_callbackPCM",
    value: function _callbackPCM(pcm) {} // end func _callbackPCM

  }, {
    key: "_callbackAAC",
    value: function _callbackAAC(adts, buffer, line1, channel, pts) {
      console.log("callbackNALU time AAC dts", pts);
    } // end func _callbackPCM

  }, {
    key: "_decode",
    value: function _decode() {
      var _this = this;

      if (this.AVDecodeInterval === undefined || this.AVDecodeInterval === null) {
        this.AVDecodeInterval = setInterval(function () {
          var item = _this.NaluBuf.shift();

          if (item !== undefined && item !== null) {
            var offset_video = Module._malloc(item.bufData.length);

            Module.HEAP8.set(item.bufData, offset_video); // decode start

            var decRet = Module.cwrap("decodeHttpFlvVideoFrame", "number", ["number", "number", "number", "number", "number"])(_this.AVSniffPtr, offset_video, item.bufData.length, item.pts, item.dts, 0); //console.log("decodeVideoFrame ret:", decRet); 
            // decode end
            //item.bufData = null;

            Module._free(offset_video);

            offset_video = null;
          }
        }, 1); // end this.AVDecodeInterval
      } // decode

    } // end func _decode

  }, {
    key: "play",
    value: function play() {
      var _this = this; // if (this.ready_now > 0) {


      var playInterval = setInterval(function () {
        // console.log("YUV cachestatus", _this.cache_status);
        if (_this.cache_status <= 0) {
          var item = _this.YuvBuf.shift();

          console.log("YUV pts", item.pts);

          if (item != undefined && item !== null) {
            RenderEngine420P.renderFrame(_this.AVGLObj, item.bufY, item.bufU, item.bufV, item.line_y, item.h);
          }

          if (_this.YuvBuf.length <= 1) {
            console.log("YUV cacheing");
            _this.cache_status = 1;
          }
        }
      }, 1000 / 35); // }
    } // end func play

  }, {
    key: "start",
    value: function start(url265) {
      var TOKEN_SECRET = "base64:QXV0aG9yOmNoYW5neWFubG9uZ3xudW1iZXJ3b2xmLEdpdGh1YjpodHRwczovL2dpdGh1Yi5jb20vbnVtYmVyd29sZixFbWFpbDpwb3JzY2hlZ3QyM0Bmb3htYWlsLmNvbSxRUTo1MzEzNjU4NzIsSG9tZVBhZ2U6aHR0cDovL3h2aWRlby52aWRlbyxEaXNjb3JkOm51bWJlcndvbGYjODY5NCx3ZWNoYXI6bnVtYmVyd29sZjExLEJlaWppbmcsV29ya0luOkJhaWR1";
      this.AVSniffPtr = Module.cwrap("AVSniffHttpFlvInit", "number", ["string", "string"])(TOKEN_SECRET, '0.0.0');
      console.log("wasmHttpFLVLoaded!!", this.AVSniffPtr);
      console.log("start add function probeCallback");
      var probeCallback = Module.addFunction(this._callbackProbe.bind(this));
      console.log("start add function yuvCallback");
      var yuvCallback = Module.addFunction(this._callbackYUV.bind(this));
      console.log("start add function naluCallback");
      var naluCallback = Module.addFunction(this._callbackNALU.bind(this));
      console.log("start add function sampleCallback");
      var sampleCallback = Module.addFunction(this._callbackPCM.bind(this));
      console.log("start add function aacCallback");
      var aacCallback = Module.addFunction(this._callbackAAC.bind(this));
      var callbackRet = Module.cwrap("initializeSniffHttpFlvModule", "number", ["number", "number", "number", "number", "number", "number"])(this.AVSniffPtr, probeCallback, yuvCallback, naluCallback, sampleCallback, aacCallback);
      console.log("create_media_processor callbackRet: ", callbackRet);
      this.AVGLObj = RenderEngine420P.setupCanvas(this.CanvasObj, {
        preserveDrawingBuffer: false
      }); // var url265 = "https://ahekv0bx0fsc5jjda5z.down.evs.bcelive.com/evs/hsnFWkELtOSv.flv?timestamp=1632799645&token=412ca3ab22886dd6faac3a405ed69de265abdb86afae91cf1861d78d05cd61e7";

      this.workerFetch.postMessage({
        cmd: "start",
        data: url265,
        msg: "start"
      });

      this._decode();

      this.play();
    } // end func startPost

  }]);
  return CHttpLiveCoreModule;
}(); // end class CHttpLiveCoreModule
// exports.CHttpLiveCore = CHttpLiveCoreModule;


exports["default"] = CHttpLiveCoreModule;

},{"./consts":2,"./webgl420":7,"@babel/runtime/helpers/classCallCheck":3,"@babel/runtime/helpers/createClass":4,"@babel/runtime/helpers/interopRequireDefault":5}],2:[function(require,module,exports){
"use strict";

/********************************************************* 
 * LICENSE: GPL-3.0 https://www.gnu.org/licenses/gpl-3.0.txt
 * 
 * Author: Numberwolf - ChangYanlong
 * QQ: 531365872
 * QQ Group:925466059
 * Wechat: numberwolf11
 * Discord: numberwolf#8694
 * E-Mail: porschegt23@foxmail.com
 * Github: https://github.com/numberwolf/h265web.js
 * 
 * 作者: 小老虎(Numberwolf)(常炎隆)
 * QQ: 531365872
 * QQ群: 531365872
 * 微信: numberwolf11
 * Discord: numberwolf#8694
 * 邮箱: porschegt23@foxmail.com
 * 博客: https://www.jianshu.com/u/9c09c1e00fd1
 * Github: https://github.com/numberwolf/h265web.js
 * 
 **********************************************************/

/*
 * Video
 *      APPEND_TYPE_STREAM 	: Uint8Array(str1 + str2 + ...)
 * 		APPEND_TYPE_FRAME	: [ {pts:xxx, data:Uint8Array(...) }, ...]
 *      APPEND_TYPE_SEQUENCE  : [ [{pts:xxx, data:Uint8Array(...) }], ...]
 * Audio
 * 		APPEND_TYPE_STREAM 	: [ Uint8Array(...) , ...]
 *		APPEND_TYPE_FRAME	: [ {pts:xxx, data:Uint8Array(...) }, ...]
 *      APPEND_TYPE_SEQUENCE  : [ [{pts:xxx, data:Uint8Array(...) }], ...]
 */
module.exports = {
  // SLICE_TAG_AUDIO: 0x08,
  // SLICE_TAG_VIDEO: 0x09,
  // PLAY_CMD: 1001,
  // DISCONN_CMD: 1002,
  DEFAILT_WEBGL_PLAY_ID: "glplayer",
  PLAYER_IN_TYPE_MP4: "mp4",
  PLAYER_IN_TYPE_FLV: "flv",
  PLAYER_IN_TYPE_HTTPFLV: "httpflv",
  PLAYER_IN_TYPE_RAW_265: "raw265",
  PLAYER_IN_TYPE_TS: "ts",
  PLAYER_IN_TYPE_MPEGTS: "mpegts",
  PLAYER_IN_TYPE_M3U8: "hls",
  PLAYER_IN_TYPE_M3U8_VOD: "m3u8",
  PLAYER_IN_TYPE_M3U8_LIVE: "hls",
  APPEND_TYPE_STREAM: 0x00,
  APPEND_TYPE_FRAME: 0x01,
  APPEND_TYPE_SEQUENCE: 0x02,
  // sec
  DEFAULT_WIDTH: 600,
  DEFAULT_HEIGHT: 600,
  DEFAULT_FPS: 25,
  DEFAULT_FRAME_DUR: 40,
  DEFAULT_FIXED: false,
  DEFAULT_SAMPLERATE: 44100,
  DEFAULT_CHANNELS: 2,
  DEFAULT_CONSU_SAMPLE_LEN: 20,
  PLAYER_MODE_VOD: "vod",
  PLAYER_MODE_NOTIME_LIVE: "live",
  AUDIO_MODE_ONCE: "ONCE",
  AUDIO_MODE_SWAP: "SWAP",
  DEFAULT_STRING_LIVE: "LIVE",
  CODEC_H265: 0,
  CODEC_H264: 1,
  PLAYER_CORE_TYPE_DEFAULT: 0,
  // 默认播放器
  PLAYER_CORE_TYPE_CNATIVE: 1,
  // 包括demuxer decoder全部走C FFmpeg Native的
  V_CODEC_NAME_HEVC: 265,
  V_CODEC_NAME_AVC: 264,
  V_CODEC_NAME_UNKN: 500,
  A_CODEC_NAME_AAC: 112,
  A_CODEC_NAME_MP3: 113,
  A_CODEC_NAME_UNKN: 500,
  CACHE_NO_LOADCACHE: 0xC0,
  CACHE_WITH_PLAY_SIGN: 0xC1,
  CACHE_WITH_NOPLAY_SIGN: 0xC2
}; // module export

},{}],3:[function(require,module,exports){
function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

module.exports = _classCallCheck;
},{}],4:[function(require,module,exports){
function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

module.exports = _createClass;
},{}],5:[function(require,module,exports){
function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {
    "default": obj
  };
}

module.exports = _interopRequireDefault;
},{}],6:[function(require,module,exports){
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _cHttpliveCore = _interopRequireDefault(require("./c-httplive-core.js"));

/********************************************************* 
 * LICENSE: GPL-3.0 https://www.gnu.org/licenses/gpl-3.0.txt
 * 
 * Author: Numberwolf - ChangYanlong
 * QQ: 531365872
 * QQ Group:925466059
 * Wechat: numberwolf11
 * Discord: numberwolf#8694
 * E-Mail: porschegt23@foxmail.com
 * Github: https://github.com/numberwolf/h265web.js
 * 
 * 作者: 小老虎(Numberwolf)(常炎隆)
 * QQ: 531365872
 * QQ群: 531365872
 * 微信: numberwolf11
 * Discord: numberwolf#8694
 * 邮箱: porschegt23@foxmail.com
 * 博客: https://www.jianshu.com/u/9c09c1e00fd1
 * Github: https://github.com/numberwolf/h265web.js
 * 
 **********************************************************/
function main() {
  var TOKEN_SECRET = "base64:QXV0aG9yOmNoYW5neWFubG9uZ3xudW1iZXJ3b2xmLEdpdGh1YjpodHRwczovL2dpdGh1Yi5jb20vbnVtYmVyd29sZixFbWFpbDpwb3JzY2hlZ3QyM0Bmb3htYWlsLmNvbSxRUTo1MzEzNjU4NzIsSG9tZVBhZ2U6aHR0cDovL3h2aWRlby52aWRlbyxEaXNjb3JkOm51bWJlcndvbGYjODY5NCx3ZWNoYXI6bnVtYmVyd29sZjExLEJlaWppbmcsV29ya0luOkJhaWR1";
  var url265 = "https://ahekv0bx0fsc5jjda5z.down.evs.bcelive.com/evs/hsnFWkELtOSv.flv?timestamp=1632799645&token=412ca3ab22886dd6faac3a405ed69de265abdb86afae91cf1861d78d05cd61e7";
  var config = {
    width: 960,
    height: 540,
    fps: 24,
    sampleRate: 44100,
    playerId: "canvas",
    token: TOKEN_SECRET,
    probeSize: 4096
  }; // config

  var liveCore = new _cHttpliveCore["default"](config);
  liveCore.start(url265);
}

window.onload = function () {};

window.addEventListener("wasmHttpFLVLoaded", function () {
  setTimeout(function () {
    main();
  }, 2000);
}); // wasmLoaded

},{"./c-httplive-core.js":1,"@babel/runtime/helpers/interopRequireDefault":5}],7:[function(require,module,exports){
"use strict";

/********************************************************* 
 * LICENSE: GPL-3.0 https://www.gnu.org/licenses/gpl-3.0.txt
 * 
 * Author: Numberwolf - ChangYanlong
 * QQ: 531365872
 * QQ Group:925466059
 * Wechat: numberwolf11
 * Discord: numberwolf#8694
 * E-Mail: porschegt23@foxmail.com
 * Github: https://github.com/numberwolf/h265web.js
 * 
 * 作者: 小老虎(Numberwolf)(常炎隆)
 * QQ: 531365872
 * QQ群: 531365872
 * 微信: numberwolf11
 * Discord: numberwolf#8694
 * 邮箱: porschegt23@foxmail.com
 * 博客: https://www.jianshu.com/u/9c09c1e00fd1
 * Github: https://github.com/numberwolf/h265web.js
 * 
 **********************************************************/
function Texture(gl) {
  this.gl = gl;
  this.texture = gl.createTexture();
  gl.bindTexture(gl.TEXTURE_2D, this.texture);
  gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.LINEAR);
  gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.LINEAR);
  gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.CLAMP_TO_EDGE);
  gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.CLAMP_TO_EDGE); //配置纹理参数
  // gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.NEAREST);
  // gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.NEAREST);
  // gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.CLAMP_TO_EDGE);
  // gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.CLAMP_TO_EDGE);
}

Texture.prototype.bind = function (n, program, name) {
  var gl = this.gl;
  gl.activeTexture([gl.TEXTURE0, gl.TEXTURE1, gl.TEXTURE2][n]);
  gl.bindTexture(gl.TEXTURE_2D, this.texture);
  gl.uniform1i(gl.getUniformLocation(program, name), n);
};

Texture.prototype.fill = function (width, height, data) {
  var gl = this.gl;
  gl.bindTexture(gl.TEXTURE_2D, this.texture);
  gl.texImage2D(gl.TEXTURE_2D, 0, gl.LUMINANCE, width, height, 0, gl.LUMINANCE, gl.UNSIGNED_BYTE, data); // gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGB, 1024, 768, 0, gl.RGB, gl.UNSIGNED_BYTE, new Uint8Array([0, 0, 0, 0]));
};

function setupCanvas(canvas, options) {
  var gl = canvas.getContext("webgl") || canvas.getContext("experimental-webgl");
  if (!gl) return gl;
  var program = gl.createProgram();
  var vertexShaderSource = ["attribute highp vec4 aVertexPosition;", "attribute vec2 aTextureCoord;", "varying highp vec2 vTextureCoord;", "void main(void) {", " gl_Position = aVertexPosition;", " vTextureCoord = aTextureCoord;", "}"].join("\n");
  var vertexShader = gl.createShader(gl.VERTEX_SHADER);
  gl.shaderSource(vertexShader, vertexShaderSource);
  gl.compileShader(vertexShader);
  var fragmentShaderSource = ["precision highp float;", "varying lowp vec2 vTextureCoord;", "uniform sampler2D YTexture;", "uniform sampler2D UTexture;", "uniform sampler2D VTexture;", "const mat4 YUV2RGB = mat4", "(", " 1.1643828125, 0, 1.59602734375, -.87078515625,", " 1.1643828125, -.39176171875, -.81296875, .52959375,", " 1.1643828125, 2.017234375, 0, -1.081390625,", " 0, 0, 0, 1", ");", "void main(void) {", " gl_FragColor = vec4( texture2D(YTexture, vTextureCoord).x, texture2D(UTexture, vTextureCoord).x, texture2D(VTexture, vTextureCoord).x, 1) * YUV2RGB;", "}"].join("\n");
  var fragmentShader = gl.createShader(gl.FRAGMENT_SHADER);
  gl.shaderSource(fragmentShader, fragmentShaderSource);
  gl.compileShader(fragmentShader);
  gl.attachShader(program, vertexShader);
  gl.attachShader(program, fragmentShader);
  gl.linkProgram(program);
  gl.useProgram(program);

  if (!gl.getProgramParameter(program, gl.LINK_STATUS)) {
    console.log("Shader link failed.");
  }

  var vertexPositionAttribute = gl.getAttribLocation(program, "aVertexPosition");
  gl.enableVertexAttribArray(vertexPositionAttribute);
  var textureCoordAttribute = gl.getAttribLocation(program, "aTextureCoord");
  gl.enableVertexAttribArray(textureCoordAttribute);
  var verticesBuffer = gl.createBuffer();
  gl.bindBuffer(gl.ARRAY_BUFFER, verticesBuffer);
  gl.bufferData(gl.ARRAY_BUFFER, new Float32Array([1.0, 1.0, 0.0, -1.0, 1.0, 0.0, 1.0, -1.0, 0.0, -1.0, -1.0, 0.0]), gl.STATIC_DRAW);
  gl.vertexAttribPointer(vertexPositionAttribute, 3, gl.FLOAT, false, 0, 0);
  var texCoordBuffer = gl.createBuffer();
  gl.bindBuffer(gl.ARRAY_BUFFER, texCoordBuffer);
  gl.bufferData(gl.ARRAY_BUFFER, new Float32Array([1.0, 0.0, 0.0, 0.0, 1.0, 1.0, 0.0, 1.0]), gl.STATIC_DRAW);
  gl.vertexAttribPointer(textureCoordAttribute, 2, gl.FLOAT, false, 0, 0);
  gl.y = new Texture(gl);
  gl.u = new Texture(gl);
  gl.v = new Texture(gl);
  gl.y.bind(0, program, "YTexture");
  gl.u.bind(1, program, "UTexture");
  gl.v.bind(2, program, "VTexture");
  return gl;
} // function renderFrame(gl, videoFrame, width, height, uOffset, vOffset) {
//     gl.viewport(0, 0, gl.canvas.width, gl.canvas.height);
//     gl.clearColor(0.0, 0.0, 0.0, 0.0);
//     gl.clear(gl.COLOR_BUFFER_BIT);
//     gl.y.fill(width, height,
//         videoFrame.subarray(0, uOffset));
//     gl.u.fill(width >> 1, height >> 1,
//         videoFrame.subarray(uOffset, uOffset + vOffset));
//     gl.v.fill(width >> 1, height >> 1,
//         videoFrame.subarray(uOffset + vOffset, videoFrame.length));
//     gl.drawArrays(gl.TRIANGLE_STRIP, 0, 4);
// }


function renderFrame(gl, videoFrameY, videoFrameB, videoFrameR, width, height) {
  gl.viewport(0, 0, gl.canvas.width, gl.canvas.height); // gl.viewport(0, 0, width + width % 4, height);

  gl.clearColor(0.0, 0.0, 0.0, 0.0);
  gl.clear(gl.COLOR_BUFFER_BIT);
  gl.y.fill(width, height, videoFrameY);
  gl.u.fill(width >> 1, height >> 1, videoFrameB);
  gl.v.fill(width >> 1, height >> 1, videoFrameR);
  gl.drawArrays(gl.TRIANGLE_STRIP, 0, 4);
}
/* Player controls Start Here */


function fullscreen() {
  var node = document.getElementById('vidPlayerComp');
  var canvas = document.getElementById('canvas');
  var childrens = node.children;
  var fullScreen;

  if (document.webkitIsFullScreen == false || document['isFullScreen'] == false || screen.height - 50 > window.innerHeight && screen.width == window.innerWidth) {
    (node.webkitRequestFullScreen || node.requestFullScreen || node.mozRequestFullScreen || node.msRequestFullscreen).call(node);
    fullScreen = true;
  } else {
    //(document.webkitCancelFullScreen()||document.cancelFullScreen()||document.mozCancelFullScreen()||document.msExitFullscreen());
    (document.webkitCancelFullScreen || document['cancelFullScreen'] || document['mozCancelFullScreen'] || document['msExitFullscreen']).call(document);
    fullScreen = false;
  }

  var innerWidth = screen.width;
  var innerHeight = screen.height;

  if (fullScreen) {
    node.setAttribute('style', 'width:' + innerWidth + 'px;' + 'height:' + innerHeight + 'px;' + 'margin-top:0px;margin-left:0px;top:0px;left:0px;background-color:black;border:2px solid rgba(17, 48, 69, 0.9);max-width:' + innerWidth + 'px;');
  } else {
    node.setAttribute('style', '');
  }

  for (var i = 0, len = node.children.length; i < len; i++) {
    if (fullScreen) {
      node.children[i].setAttribute('style', 'width:' + innerWidth + 'px;' + 'height:25px;');
    } else {
      node.children[i].setAttribute('style', '');
    }

    if (i === 1) {
      if (fullScreen) {
        node.children[i].setAttribute('style', 'height:' + (innerHeight - 54) + 'px;' + 'width:' + innerWidth + 'px');
        canvas.style.width = innerWidth + 'px';
        canvas.style.height = innerHeight - 54 + 'px';
      } else {
        node.children[i].setAttribute('style', '');
        canvas.setAttribute('style', '');
      }
    }
  }
} // exports.setupCanvas = setupCanvas;
// alert(module);
// console.warn(module);


module.exports = {
  renderFrame: renderFrame,
  setupCanvas: setupCanvas
};

},{}]},{},[6]);
